#pragma semicolon 1
#pragma newdecls required

#include <sourcemod>
#include <sdkhooks>
#include <clientprefs>
#include <sdktools>
#include <csgo_colors> // hlmod.ru/resources/inc-cs-go-colors.1009/
#include <vip_core> // hlmod.ru/resources/vip-core.245/

static const char g_sFeature[] = "MKIT";

int kit[MAXPLAYERS+1], m_unMusicID;
Handle g_hCookie;
Menu g_hmenu;

public Plugin myinfo = 
{
	name = "[VIP] Music Kit", 
	author = "Pheonix, Felya, crashzk", 
	version = "1.1.4",
	url = "hlmod.ru"
};

public void OnPluginStart()
{	
	m_unMusicID = FindSendPropInfo("CCSPlayer", "m_unMusicID");
	
	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
	
	g_hCookie = RegClientCookie(g_sFeature, g_sFeature, CookieAccess_Protected);
	
	g_hmenu = new Menu(MkitMenuHandler);
	g_hmenu.ExitBackButton = true;
	
	LoadTranslations("vip_modules.phrases"); // Файл перевода VIP
	LoadTranslations("vip_mkit.phrases"); // Файл перевода плагина
	
	RegConsoleCmd("sm_music", cmd_openmenu);
}

public void OnPluginEnd() // Спасибо крузе (сам забыл про это :D)
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, BOOL, SELECTABLE, Open_mkit);
}

public void OnClientDisconnect(int iClient)
{
	kit[iClient] = 0;
}

public void VIP_OnVIPClientLoaded(int iClient)
{
	char sCookieValue[10];
	GetClientCookie(iClient, g_hCookie, sCookieValue, sizeof(sCookieValue));
	kit[iClient] = StringToInt(sCookieValue);
}

public Action cmd_openmenu(int iClient, int argc)
{
	if (VIP_IsClientVIP(iClient)) 
	{
		g_hmenu.Display(iClient, MENU_TIME_FOREVER);
	}
	
	return Plugin_Handled;
}

public bool Open_mkit(int iClient, const char[] sFeatureName)
{
	g_hmenu.Display(iClient, MENU_TIME_FOREVER);
	return false;
}

public void OnMapStart()
{
	char sInfo[128];
	KeyValues hKeyValues = new KeyValues(g_sFeature);
	BuildPath(Path_SM, sInfo, sizeof(sInfo), "data/vip/modules/mkit.ini");
	if(hKeyValues.ImportFromFile(sInfo))
	{
		g_hmenu.RemoveAllItems();
		g_hmenu.SetTitle("Выберите свой музыкальный комплект\n ");
		g_hmenu.AddItem("1", "Удалить музыкальный комплект\n ");
		if(hKeyValues.GotoFirstSubKey(false))
		{
			char sNum[16];
			do
			{
				hKeyValues.GetSectionName(sNum, sizeof(sNum));
				hKeyValues.GetString(NULL_STRING, sInfo, sizeof(sInfo));
				g_hmenu.AddItem(sNum, sInfo);
			}
			while (hKeyValues.GotoNextKey(false));
		}
	}
	else
    {
        SetFailState("[MKIT] %s - is not found", sInfo);
    }
	
	delete hKeyValues;
	
	SDKHook(GetPlayerResourceEntity(), SDKHook_ThinkPost, OnThinkPost);
}

public int MkitMenuHandler(Menu hmenu, MenuAction action, int iClient, int Item) // спасибо Walderr'y
{
	switch(action)
	{
		case MenuAction_Select:
		{
			char sInfo[10],sFormat[128];
			g_hmenu.GetItem(Item, sInfo, 10);
			kit[iClient] = StringToInt(sInfo);
			save_mkit(iClient, kit[iClient]);
			FormatEx(sFormat, sizeof(sFormat), "%t", "Change_mkit");
			CGOPrintToChat(iClient, sFormat);
			g_hmenu.DisplayAt(iClient, GetMenuSelectionPosition(), MENU_TIME_FOREVER);
		}
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) VIP_SendClientVIPMenu(iClient);
		}
	}	
}

void OnThinkPost(int iEnt)
{
	for(int i = MaxClients + 1; --i;)
	{
		if(kit[i])
		{
			SetEntData(i, m_unMusicID, kit[i]);
		}
	}
} 

public Action save_mkit(int iClient, int mkit)
{
	char sCookieValue[10];
	IntToString(mkit, sCookieValue, sizeof(sCookieValue));
	SetClientCookie(iClient, g_hCookie, sCookieValue);
}
